#include "RaveBase/Converters/interface/MagneticFieldWrapper.h"
#include "RaveBase/RaveInterface/rave/RaveVector3D.h"

using namespace std;

GlobalVector MagneticFieldWrapper::inTesla ( const GlobalPoint & gp ) const
{
  if ( !theField )
  {
    cout << "[MagneticFieldWrapper] Arrg! No field registered!" << endl;

  }
  rave::Vector3D rv = theField->inTesla( rave::Point3D( gp.x(), gp.y(), gp.z() ) );
  return GlobalVector( rv.x(), rv.y(), rv.z() );
  // return theField->inTesla ( o );
}

MagneticFieldWrapper::MagneticFieldWrapper() : theField(0)
{
  // cout << "[MagneticFieldWrapper] empty con'tor" << endl;
}

MagneticFieldWrapper::MagneticFieldWrapper( const MagneticFieldWrapper & o )
{
  cout << "[MagneticFieldWrapper] Arrgh! Fatal!" << endl;
}

MagneticFieldWrapper * MagneticFieldWrapper::Instance()
{
  static MagneticFieldWrapper singleton;
  return &singleton;
}

void MagneticFieldWrapper::registry ( const rave::MagneticField & field )
{
  // cout << "[MagneticFieldWrapper] registering field" << endl;
  if ( theField ) delete theField;
  theField=field.copy();
}
