#include "RaveBase/RaveEngine/interface/RaveReconstructor.h"
#include "RaveBase/RaveEngine/interface/RaveStrategyBuilder.h"

using namespace std;

vector < TransientVertex > RaveReconstructor::vertices
  ( const vector < reco::TransientTrack > & t ) const
{
  return theRector->vertices ( t );
}

RaveReconstructor::~RaveReconstructor()
{
  if ( theRector ) delete theRector;
}

RaveReconstructor::RaveReconstructor ( const std::string & d ) :
  theRector ( 0 )
{
  RaveStrategyBuilder builder ( d );
  theRector = builder.reconstructor();
  if (!theRector ) 
  {
    cout << "[RaveReconstructor] error: no reconstructor instantiated!"
         << endl;
  }
}

RaveReconstructor::RaveReconstructor ( const RaveReconstructor & o ) :
  theRector ( 0 )
{
  if ( o.theRector ) theRector=o.theRector->clone();
}

RaveReconstructor * RaveReconstructor::clone() const
{
  return new RaveReconstructor ( *this );
}
