#include "RaveBase/RaveInterface/rave/RaveCalibration.h"

using namespace rave;
using namespace std;

void Calibration::add ( const rave::CalibrationHistogram & a )
{
  theHistos.push_back ( a );
}

void Calibration::add ( const rave::CalibrationRun & a )
{
  theRuns.push_back ( a );
}

void Calibration::dump() const
{
  for ( vector< CalibrationHistogram >::const_iterator i=theHistos.begin(); 
        i!=theHistos.end() ; ++i )
  {
    i->dump();
  }
}

std::vector < rave::CalibrationRun > Calibration::runs() const
{
  return theRuns;
}

std::vector < rave::CalibrationHistogram >::const_iterator Calibration::begin() const
{
  return theHistos.begin();
}

std::vector < rave::CalibrationHistogram >::const_iterator Calibration::end() const
{
  return theHistos.end();
}

size_t Calibration::size() const
{
  return theHistos.size();
}
