#include "RaveBase/Utilities/interface/StringTools.h"
#include <cstdlib>
#include <iostream>

using namespace std;
using namespace StringTools;

//------------------------------------------------------------
string::size_type
StringTools::find_unescaped( const string & src, const string & sub )
{

  string::size_type pos(0);
  // walk the string WHILE finding escaped....
  do
  {
     pos = src.find( sub, pos );
     //cout << "[find_unescaped]: found pos " << pos << endl;
     if( pos > 0 && src[pos-1] == '\\' )
     {
       pos++;
       //cout << "escaped !!!" << endl;
       continue;
     }
     else
       break;
  }
  while( pos != string::npos );

  return pos;
}


//------------------------------------------------------------
string::size_type
StringTools::rfind_unescaped( const string & src, const string & sub )
{

  string::size_type pos(src.size());
  // walk the string WHILE finding escaped....
  do
  {
     pos = src.rfind( sub, pos );
     cout << "[rfind_unescaped]: found pos " << pos << endl;
     if( pos > 0 && src[pos-1] == '\\' )
     {
       pos--;
       cout << "escaped !!!" << endl;
       continue;
     }
     else
       break;
  }
  while( pos != string::npos );

  return pos;
}


//------------------------------------------------------------
string &
StringTools::lstrip( string & source )
{
    while( source.size() && isspace(source[0]) )
    { source.replace ( 0, 1, "" ); };

    return source;
}


//------------------------------------------------------------
string &
StringTools::rstrip( string & source )
{
    while( source.size() && isspace(source[source.size()-1]) )
    { source.replace ( source.size()-1, 1, "" ); };

    return source;
}


//------------------------------------------------------------
string &
StringTools::strip( string & source )
{
    lstrip( rstrip(source) );

    return source;
}


//------------------------------------------------------------
list< string > 
StringTools::split( string source, string sep, unsigned int num )
{
  list< string > ret;
  string::size_type foundpos(0);
  const string::size_type sep_size( sep.size());
  unsigned int found = 0;

  while( (foundpos = find_unescaped( source, sep )) != 
      string::npos )
  {
    string sub = source.substr( 0, foundpos );
    //cout << __FUNCTION__ << ": " << sub << endl;
    if( sub.size() ) 
    {
      found++;
      ret.push_back( sub );
    }
    source.replace( 0, foundpos + sep_size, "" );
    // quit splitting if required times have been done
    if( num && found >= num )
      break;
  };
  if( source.size() ) 
    ret.push_back( source );

  return ret;
}

