#include "DataFormats/VertexReco/interface/Vertex.h"
// #include "DataFormats/TrackReco/interface/Track.h"
// #include "DataFormats/TrackReco/interface/TrackFwd.h"
#include <iostream>

// this class' header
#include "RecoVertex/VertexTools/interface/NbSharedTracks.h"

using namespace std;

int reco::NbSharedTracks::sharedTracks(const reco::Vertex &v1,
               const reco::Vertex &v2) const {
  // return 0;
  int nSharedTracks = 0;

  // for first vertex
  track_iterator v1TrackIter;
  track_iterator v1TrackBegin = v1.tracks_begin();
  track_iterator v1TrackEnd   = v1.tracks_end();
  

  // for second vertex
  track_iterator v2TrackIter;
  track_iterator v2TrackBegin = v2.tracks_begin();
  track_iterator v2TrackEnd   = v2.tracks_end();
  
  for (v1TrackIter = v1TrackBegin; v1TrackIter != v1TrackEnd; v1TrackIter++) {
    for (v2TrackIter = v2TrackBegin; v2TrackIter != v2TrackEnd; v2TrackIter++) {
      #ifdef RAVE
      if ( (**v1TrackIter).id() == (**v2TrackIter).id() ) {
      #else
      if ( (*v1TrackIter) == (*v2TrackIter) ) {
      #endif
        nSharedTracks++;
      } // if 
    } // for v2TrackIter
  } //for v1TrackIter

    /*
  cout << "[NbSharedTracks] FIXME check if it works: v1.size=" << v1.tracksSize()
       << ", v2.size=" << v2.tracksSize() << ", nshared=" << nSharedTracks << endl;
       */

  return nSharedTracks;
} // int sharedTracks
